#ifndef GCCOMMON_H
#define GCCOMMON_H GCCOMMON_H

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;
typedef unsigned __int64 u64;

typedef signed char s8;
typedef signed short s16;
typedef signed int s32;
typedef signed __int64 s64;

typedef float f32;

inline void toWORD(u16& w)
{
    u8 w1 = w & 0xff;
    u8 w2 = w >> 8;
    w = (w1 << 8) | w2;
}

inline void toSHORT(s16& w)
{
    toWORD(*(u16*)&w);
}

inline u16 aWORD(u16 w)
{
    toWORD(w);
    return w;
}

inline void toDWORD(u32& d)
{
    u8 w1 = d & 0xff;
    u8 w2 = (d >> 8) & 0xff;
    u8 w3 = (d >> 16) & 0xff;
    u8 w4 = d >> 24;
    d = (w1 << 24) | (w2 << 16) | (w3 << 8) | w4;
}

inline void toQWORD(u64& d)
{
    u32* w0 = (u32*)(&d);
    u32 w1 = w0[1];
    w0[1] = w0[0];
    w0[0] = w1;

    toDWORD(w0[0]);
    toDWORD(w0[1]);
}

inline void toFLOAT(f32& f)
{
    toDWORD(*(u32*)&f);
}

inline u32 aDWORD(u32 d)
{
    toDWORD(d);
    return d;
}

inline s16 aSHORT(s16 s)
{
    return aWORD(*(u16*)&s);
}

inline u64 aQWORD(u64 q)
{
    toQWORD(q);
    return q;
}

#endif //GCCOMMON_H
